		TITLE   "ETHEREAL-15GW"
		LIST    P=16F84

INDIR   EQU     00H     ; Indirect pointer
RTCC    EQU     01H     ; Real time clock / counter
PCL     EQU     02H     ; Program counter low byte
STATUS  EQU     03H     ; Status register
CY      EQU     0       ; Carry/borrow bit
DC      EQU     1       ; Digit carry
Z       EQU     2       ; Zero flag
PD      EQU     3       ; Power down
T0      EQU     4       ; Time-out bit
RP0     EQU     5       ; Register page select bits
RP1     EQU     6       ; Not used in 16C84
RP2     EQU     7       ; Not used in 16C84
FSR     EQU     04H     ; Indirect pointer
PORTA   EQU     05H     ; PORT A
PORTB   EQU     06H     ; PORT B
EEDATA  EQU     08H     ; Eeprom data
EEADR   EQU     09H     ; Eeprom address
PCLATH  EQU     0AH     ; Program counter high byte
INTCON  EQU     0BH     ; Interrupt control
TRISA   EQU     085H    ; Data direction port A
TRISB   EQU     086H    ; Data direction port B
EECON1  EQU     088H    ; Eeprom control
RD	EQU	0	; Start reading from EEPROM

W       EQU     0       ; W reg. as destination
F       EQU     1       ; F file as destination

SDA	EQU	4
SCK	EQU	5

	;  ६ :

	; 2Bh -  ६ ஢
	; 2Ch -  UA,   
	; 2Dh - ⨯ 樨
	; 2Eh - ஢, ண ᬮਬ (᭮)
	; 2Fh -   ६⮬ 
	; 4Ah -  ⥪饣 ஢
	; 4Bh - 㯯 ஢஢, UA    (XOR 0F)

TMP	EQU	28H
PRV	EQU	2BH
PROV	EQU	4AH

LAST_DATE	EQU	0		;᫥  । 몮
					; 㤥 ⠢ ஬

		ORG     0000H

		GOTO    Start

		ORG	0001H

		RETLW   024H		;1    
		RETLW   002H		;2  (   -
		RETLW   004H		;3     樨-⠭樨)
		RETLW   006H		;4
		RETLW   0B8H		;5
		RETLW   0A4H		;6
		RETLW   0C0H		;7
;  - - /  -  
		RETLW   0ACH		;8
		RETLW   018H		;9
		RETLW   0F0H		;A
		RETLW   0F8H		;B
		RETLW   026H		;C
		RETLW   088H		;D

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Start		CALL	StdDelay_7F	; W <- 7Fh
;		OPTION			;    ⠭
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Start		CLRW
		CALL	Delay_7F	; W <- 7Fh
		OPTION			;    ⠭
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		MOVLW   .10
_send_ATR_	MOVWF   2EH		;뫪 ATR - 10 
		ADDLW	030H-1
		CALL    Read_EEPROM	; ⥭  EEDATA
		CALL    SEND_EEDATA_FF
		CALL	StdDelay_7F
		DECFSZ  2EH,W		;樠஢ ஢, ண 
		GOTO    _send_ATR_	; ᬮਬ ᭮,    2e - 01
		TRIS    PORTA		;PORTA  뢮  樨 ; W=0
		MOVLW	0D0H		;㯯 ஢஢   D0h
		CALL	Rnd_Read_IIC	;⠥ 㯯 ஢஢,
		ANDLW	00FH		;뤥塞 訩 
		MOVWF	4BH		; UA   
		ADDWF	4BH,W		;  ࠭塞  4b
		ADDWF	4BH,W
		SUBLW	053H		;  ࠭ 
		MOVWF	2CH		; (UA   24c16   4Bh)
		ADDWF	2CH,F		; 塞 UA  2c
Remote_Key	MOVF	4CH,W
		MOVWF	2FH		;࠭塞    2f
MainLoop_LED	CLRF	PORTA		; ᢥ⮤
MainLoop	MOVF	PROV,W		;⠢ ⨭
		MOVWF	PRV		; ஢
		MOVLW   090H		;뫪 ⢥ 90 0x
AltMainLoop	CALL    SEND_FF
		RRF	PCLATH,W	;뤥塞  訡 
		ANDLW   008H		; 뫠 00 (OK)  08 (Err)
		CALL    SEND_FF
ReRead_Command	CALL    RECV		;⠥
		MOVWF   4FH		;  
		CALL    RECV		;⠥ 
		MOVWF   4CH		; 
		CALL    RECV		;⠥
		MOVWF   4DH		; P1
		CALL    RECV		;⠥
		MOVWF   4EH		; P2
		INCFSZ	4FH,W		; ⠭   FF  ?
		GOTO	Baud_9600	; 㤥  115200  - Red CAM
		MOVF    4FH,W
		CALL    SEND_FF
		MOVF    4CH,W
		CALL    SEND_FF
		MOVF    4DH,W
		CALL    SEND_FF
		MOVF    4EH,W
		CALL    SEND_FF
		BSF     INTCON,003H	;⠢ 䫠 115200
		GOTO    ReRead_Command

Rotate_SubKey	SWAPF   23H,W		;饭  
		ADDLW   080H		; 23h.3 -> STATUS.CY
		BCF     23H,003H
		RLF     26H,F
		RLF     25H,F
		RLF     24H,F
		RLF     23H,F
		RLF     22H,F
		RLF     21H,F
		RLF     20H,F
		BTFSC   STATUS,CY
		BSF     23H,004H
		RETLW	008H		; W <- 8

Baud_9600	CALL    RECV		;⠥
		MOVWF   4FH		; P3 - ⢮   뫪
		CLRF    PCLATH		;⪠ 䫠 訡   24c16
		MOVLW   .13		;ন 13 
_command_scan_	MOVWF   29H		;  
		CALL    W_PCL		;  ⠡
		XORWF   4CH,W
		BTFSC   STATUS,Z
		GOTO    CommandFound
		DECFSZ  29H,W
		GOTO    _command_scan_
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		GOTO	MainLoop	;  , 諥 OK
					; (   6B 00)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;		MOVLW	06BH
;		GOTO	AltMainLoop	;  , 諥 6B 00
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

CommandFound	BTFSC	29H,03H		;஢ઠ 
		GOTO    _no_receipt_	; 樨-⠭樨
		MOVF    4CH,W		;⢥ত 뫪  
		MOVF    4FH,F		;᫨ 襭  
		BTFSS   STATUS,Z	; - 祣  뫠
		CALL    SEND_FF
_no_receipt_	MOVF    29H,W		;୮ ⢫
		ADDLW   W_PCL		;   

		ORG	062H

W_PCL		MOVWF   PCL		;୮ ⢫
		GOTO    INS_CA24	;⢨, ⢥ত PIN-
		GOTO    INS_8702	;  ⥭  FAC
		MOVLW	0A6H^066H^0AEH	;⥭    FAC ; INS_8704
		GOTO    INS_8704_8706	;⥭ ᮤন  FAC ; W = 66h
		GOTO    INS_CAB8	;⥭ 樨
		GOTO    INS_CAA4	;롮 䠩/⠫
		GOTO    INS_CAC0	;⥭ ஢ ᫮
		GOTO    INS_CAAC	;  
		GOTO    INS_CA18	; 祩
		BSF	PCLATH,004H	; 樨 (CAF0) ; 䫠 訡
		GOTO    INS_CAF0_CAF8	; (CAF8)
		GOTO    AltMainLoop	;INS_CA26 - ⢥ 6E 00 ; W = 6Eh
		;	INS_CA88	 । ஢ ᫮
INS_CA88	ANDWF	4EH,W		; W = 6Fh
		MOVWF	PORTA		;⮡ࠧ    LED
		COMF	PRV,W		;  ஢,
		MOVWF	2EH		; ண ᬮਬ ᭮  2e
		CALL    CryptoPreludeX8	; ५  ਯ⮣䨨
		CALL    Test_Nano	;ࠡ⪠  ; W <- 18h
		BTFSS	PCLATH,04H	;ࠢ   ?
		GOTO	_continue_CA88_
		BTFSC	INTCON,06H	;஢ 䫠 ॣ㧠  Wrong_Key
		GOTO	$		;⠢ CAM ॣ㧨
_continue_CA88_	CALL    Move8_to_18	;஢ c 30h..37h  18h..1Fh
		CALL    DES		;஢ ࢮ ᫮ ; W <- Ch
		MOVWF   EEADR		;஢ ࢮ .᫮
		CALL	Move4_		;  ᮢ 18h..1Fh   | ᫥ DES
		CALL    Move4_		;  ᠬ 0Ch..13h  | FSR = 18h
		MOVLW   020H		;஢  38h..3Fh  18h..1Fh
		CALL    Move8_to_18	;஢ ண .᫮
		CALL    DES		;஢ ண ᫮
		CALL    Move4_1C_18 ;஢  R ண .᫮
		GOTO    MainLoop ;  L 㦥 뫠  ᠬ 14h..17h

INS_CA18	CALL	CryptoPreludeX8	; ५  ਯ⮣䨨
		BTFSS	4DH,01H		;  CA1802
		GOTO	INS_CA1800_1801
		MOVF	2CH,W		;  UA
		CALL	Set_Addr_IIC
		MOVLW	01BH		;⥭ UA :
		MOVWF	FSR		; 㦠
_load_UA_	CALL	Seq_Read_IIC	;  UA
		MOVWF	INDIR		;  
		INCF	FSR,F		; 
		BTFSS	FSR,05H		; ᠬ
		GOTO	_load_UA_	; 1Bh..1Fh
		CALL	DES		;Hash
INS_CA1800_1801	CALL	Test_Nano
		BTFSC   PCLATH,04H      ; 訡 ?
		GOTO    MainLoop
NextUpdate	MOVF    48H,W		; 騥
		XORLW   00CH		; ID/ ࠭
		BTFSC   STATUS,Z	;᫨ ,
		GOTO    MainLoop	;   ⮬ 
		MOVF    49H,W		; 砫 ᫥ 祭
		ADDLW   0F8H		; ஢ 
		MOVWF   49H		;⪠뢠 㪠⥫   8
		ADDLW   0E8H		;㥬 ஢ 
		CALL    Move8_to_18	;    18h..1Fh
		CALL    DES		;஢뢠 
		DECF	48H,F		;⪠⨫  2 㪠⥫ 
		DECF	48H,F		;   ID/祩
		MOVF	48H,W		;⥫  
		MOVWF   FSR		;ID/祩  FSR
		MOVF    INDIR,W		;ࠫ ன 
		MOVWF   RTCC		; ID- ஢  RTCC
		INCF	FSR,F		;ࠫ ⨩ 
		MOVF    INDIR,W		; ID- ஢  箬
		CALL    Prov_Search
		BTFSC	STATUS,CY	;஢   ⠪ ஢
		GOTO	NextUpdate
		MOVLW	018H		; FSR <- 18H ᫥饩 ணࠬ
		CALL    FSR_KeyAddr_IIC	;饭   24c16
_key_compare_	CALL    Seq_Read_IIC	;ࠢ 饣 
		XORWF   INDIR,W		;  㦥 யᠭ
		BTFSS   STATUS,Z
		GOTO    KeyUpdate
		INCF    FSR,F
		BTFSS   FSR,05H   
		GOTO    _key_compare_
		GOTO    NextUpdate

INS_CAB8	BCF	STATUS,007H	;⠢ 䫠 " CAAC_CAB8"
		BTFSS   STATUS,06H	;஢ઠ 뫠  ।
		GOTO    _without_CAAC_	; CAB8  CAAC
		BCF     STATUS,006H	; 䫠 "CAAC"
		BSF	STATUS,007H	; 䫠 " CAAC_CAB8"
		MOVF    2DH,W		; 樨
		CALL    DEC_SEND_FF	;᫠   ⢥ত
		DECFSZ	4FH,W		;஢ઠ   樨 = 1
_without_CAAC_	BSF     PCLATH,004H	;⠢ 䫠 訡
	;;;	MOVF	PRV,W		; 樨 A7  
	;;;	BTFSS	STATUS,Z	; 뢮  
	;;;	MOVF    2DH,W		; "Ethereal-15GW"
	;;;	XORLW	0A7H		;஢ઠ   A7
	;;;	BTFSC	STATUS,Z
	;;;	GOTO	Consult_A7
		BSF	PCLATH,001H	;樨   2 24c16
		CLRW			;樨  24c16   200h
		CALL	Set_Addr_IIC	; 樨 ; TMP <- W
_consult_srch_	CALL    Seq_Read_IIC	;  ᯨ᪥
		BTFSC	STATUS,Z	;᫨  ,   
		GOTO	Consult_A4_A5	; A4  UA  A5  PPUA ; W = 0
		INCF	TMP,F
		XORWF   2DH,W
		BTFSS   STATUS,Z
		GOTO    _consult_srch_
		DECF	TMP,W
		CALL	W_PCL
		GOTO	SEND_CONSULT

INS_CAA4	BCF	INTCON,006H	; 䫠 ॣ㧠  Wrong_Key
		BTFSC   4DH,01H		;롮 ஢
		GOTO    INS_CAA402	;CAA402 - Next - ᫥饣
		BTFSS   4DH,02H
		GOTO    INS_CAA400	;CAA400 - ISSUER - ᠬ 孥
		;			 CAA404 - Select -   ID
INS_CAA404	CALL    RECV		;⥭ 1-  ID - 塞
		CALL    RECV		;⥭ 2-  ID
		MOVWF   RTCC		;  RTCC 
		CALL    RECV		;⥭ 3-  ID  W
		CALL    Prov_Search	; ஢  ID
		MOVF	PRV,W
		BTFSS	STATUS,CY	;  ஢ ?
		MOVWF	PROV		;㠫  ஢
		COMF	EEDATA,W
		ANDLW	00FH
		MOVWF	4CH
		BTFSS	STATUS,Z	;   UA  ⮣ ஢ ?
		XORWF	4BH,W		;஢     㦥
		BTFSS	STATUS,CY	;    ஢ ?
		BTFSC	STATUS,Z	;   UA
		GOTO	MainLoop
		BSF	INTCON,006H	;⠢ 䫠 ॣ㧠  Wrong_Key
		CLRF	PCLATH		; 㯯  ࠭ 0 24c16
		MOVLW	0D0H		;࠭塞  㯯  MUA
		CALL	Write_4C_IIC	;   D0h  24c16
		GOTO    MainLoop

INS_CA24	ADDLW	-11H		;।᫥ ⠭ 
		MOVWF   4CH		; ( 11h) ࠭塞  4c
		CALL    RECV		;᫥ ⠭   EEDATA
		DECFSZ  4FH,F
		GOTO    INS_CA24
		DECFSZ	4DH,W		;஢ઠ  CAA2401
		GOTO	MainLoop
		BTFSC	EEDATA,05H	;⠭
		BSF	4CH,007H	; 
		BTFSC	EEDATA,04H	; ६⮬
		BSF	4CH,003H	; 
		BTFSC	EEDATA,06H	;஢ઠ    
		GOTO	Remote_Key
		BTFSC	2EH,07H		;஢ઠ  ६  FTA 
		CALL	Remote_Byte	; ६⭮ 
		GOTO	MainLoop

Erase8_18	CALL    FSR_18h		;18h -> FSR
_erase_		CLRF    INDIR		;㫨 ਯ⮡ 18h..1Fh
		INCF    FSR,F
		BTFSS   FSR,05H   
		GOTO    _erase_
		RETURN

Read_EEPROM	MOVWF	EEADR		;⥭   EEPROM 
Read_EEADR	BSF	STATUS,005H
		BSF	EECON1,RD
		BCF	STATUS,005H
		RETLW	007H		; ⥭  EEDATA ; W <- 7

S_Box_Table_1	IORLW	040H
S_Box_Table_2	CALL    W_PCL		; S-BOX
		MOVWF   EEDATA

		ORG	100H

		RETLW   0D7H		;00
		RETLW   01DH		;01
		RETLW   02DH		;02
		RETLW   0F8H		;03
		RETLW   08EH		;04
		RETLW   0DBH		;05
		RETLW   043H		;06
		RETLW   085H		;07
		RETLW   060H		;08
		RETLW   0A6H		;09
		RETLW   0F6H		;0A
		RETLW   03FH		;0B
		RETLW   0B9H		;0C
		RETLW   070H		;0D
		RETLW   01AH		;0E
		RETLW   043H		;0F
		RETLW   0A1H		;10
		RETLW   0C4H		;11
		RETLW   092H		;12
		RETLW   057H		;13
		RETLW   038H		;14
		RETLW   062H		;15
		RETLW   0E5H		;16
		RETLW   0BCH		;17
		RETLW   05BH		;18
		RETLW   001H		;19
		RETLW   00CH		;1A
		RETLW   0EAH		;1B
		RETLW   0C4H		;1C
		RETLW   09EH		;1D
		RETLW   07FH		;1E
		RETLW   029H		;1F
		RETLW   07AH		;20
		RETLW   023H		;21
		RETLW   0B6H		;22
		RETLW   01FH		;23
		RETLW   049H		;24
		RETLW   0E0H		;25
		RETLW   010H		;26
		RETLW   076H		;27
		RETLW   09CH		;28
		RETLW   04AH		;29
		RETLW   0CBH		;2A
		RETLW   0A1H		;2B
		RETLW   0E7H		;2C
		RETLW   08DH		;2D
		RETLW   02DH		;2E
		RETLW   0D8H		;2F
		RETLW   00FH		;30
		RETLW   0F9H		;31
		RETLW   061H		;32
		RETLW   0C4H		;33
		RETLW   0A3H		;34
		RETLW   095H		;35
		RETLW   0DEH		;36
		RETLW   00BH		;37
		RETLW   0F5H		;38
		RETLW   03CH		;39
		RETLW   032H		;3A
		RETLW   057H		;3B
		RETLW   058H		;3C
		RETLW   062H		;3D
		RETLW   084H		;3E
		RETLW   0BEH		;3F
		RETLW   04AH		;40
		RETLW   0DDH		;41
		RETLW   0B0H		;42
		RETLW   007H		;43
		RETLW   029H		;44
		RETLW   0B0H		;45
		RETLW   0EEH		;46
		RETLW   079H		;47
		RETLW   0F6H		;48
		RETLW   043H		;49
		RETLW   003H		;4A
		RETLW   094H		;4B
		RETLW   08FH		;4C
		RETLW   016H		;4D
		RETLW   0D5H		;4E
		RETLW   0AAH		;4F
		RETLW   031H		;50
		RETLW   0E2H		;51
		RETLW   0CDH		;52
		RETLW   038H		;53
		RETLW   09CH		;54
		RETLW   055H		;55
		RETLW   077H		;56
		RETLW   0CEH		;57
		RETLW   05BH		;58
		RETLW   02CH		;59
		RETLW   0A4H		;5A
		RETLW   0FBH		;5B
		RETLW   062H		;5C
		RETLW   08FH		;5D
		RETLW   018H		;5E
		RETLW   061H		;5F
		RETLW   01DH		;60
		RETLW   061H		;61
		RETLW   046H		;62
		RETLW   0BAH		;63
		RETLW   0B4H		;64
		RETLW   0DDH		;65
		RETLW   0D9H		;66
		RETLW   080H		;67
		RETLW   0C8H		;68
		RETLW   016H		;69
		RETLW   03FH		;6A
		RETLW   049H		;6B
		RETLW   073H		;6C
		RETLW   0A8H		;6D
		RETLW   0E0H		;6E
		RETLW   077H		;6F
		RETLW   0ABH		;70
		RETLW   094H		;71
		RETLW   0F1H		;72
		RETLW   05FH		;73
		RETLW   062H		;74
		RETLW   00EH		;75
		RETLW   08CH		;76
		RETLW   0F3H		;77
		RETLW   005H		;78
		RETLW   0EBH		;79
		RETLW   05AH		;7A
		RETLW   025H		;7B
		RETLW   09EH		;7C
		RETLW   032H		;7D
		RETLW   027H		;7E
		RETLW   0CCH		;7F

KeyUpdate	CALL    Set_KeyAddr_IIC	;饭   24c16 ; W <- 6Fh
		ANDWF	4EH,W		;⮡ࠧ 騩
		MOVWF	PORTA		;   ᢥ⮤
		CALL    Save_18_1F_24xx	;  
		GOTO    NextUpdate	; ᫥騩  

Consult_A4_A5	BCF	PCLATH,001H	;  UA  PPUA   0 ; W = 0
		CALL	Add_Prov_mul_5	;  PPUA  2464   0
		BTFSS	2DH,00H
		DECF	2CH,W		;, 塞 UA  24c16
		GOTO	SEND_CONSULT	;᫠ 

Move4_1C_18	MOVLW   004H		;஢ 4- 
		MOVWF   EEADR		;  ᮢ 1Ch..1Fh
		MOVLW   01CH		;  ᠬ 18h..1Bh
Move4		MOVWF   FSR		;஢ 4- 
Move4_		CALL    Move2
Move2		CALL    Move
Move		MOVF    INDIR,W		;஢ 
		MOVWF   EEDATA		; FSR -  筨
		MOVF    EEADR,W		; EEADR -  ७ 
		SUBWF   FSR,F
		MOVF    EEDATA,W
		MOVWF   INDIR
		INCF    EEADR,W
		ADDWF   FSR,F
		RETLW	0F8H		; W <- 0F8h

Nano_E1_E2	DECF	4FH,F		;४㥬  
		DECF	4FH,F		;४㥬  
		CALL    InvSEND_RECV	;竨   
		MOVWF	4DH		;  ࠭  4d
		CALL    BNano_InvSndRcv	;竨 ன  
		SUBLW	LOW(LAST_DATE)
		MOVLW	HIGH(LAST_DATE)
		BTFSC	STATUS,CY
		ADDLW	001H
		SUBWF	4DH,W
		BTFSC	STATUS,CY
		COMF	24H,F		;⨬   -   
		CALL    Byte_Nano	;ࠡ  
		GOTO	NanoData_Accept	;ࠡ ⠫  

CryptoPreludeX8	DECFSZ	4DH,W		; CAx801 祭  ࠭
CryptoPreludeFX	CALL	Erase8_18	;  18h..1Fh
		CALL    KeyAddr_2416
		BSF     INTCON,004H	;⠢ 䫠 HASH
		MOVLW	020H		;⥭ 
		CALL    FSR_KeyAddr_IIC	; ஢  
_load_KEY_	CALL	Seq_Read_IIC	;  ᠬ 20h..27h
		BTFSS	4EH,03H		; - ?
		XORWF	TMP,W		;஢  
		ADDWF	TMP,F		;஢ 
		MOVWF	INDIR
		INCF	FSR,F
		BTFSS	FSR,03H
		GOTO	_load_KEY_
		CLRF	PCLATH		; 䫠 訡   24c16
		MOVLW	030H		;樠㥬 㪠⥫
		MOVWF   49H		;   ஢ ᫮
		MOVLW   00CH		;Ch - 砫   ID/祩
		MOVWF	48H		;⥫   ন  48
		GOTO	FSR_18h

Send_ID_Entity	MOVLW	0D3H		; c D3h  24c16 ID- ஢
		CALL	Add_Prov_mul_3	;뢠  ID- ஢
		CALL	Rnd_Read_IIC	;뫪
		CALL	DEC_SEND_FF	;
		CALL	Seq_Read_IIC	; ID-
		CALL    DEC_SEND_FF	;
		CALL	Seq_Read_IIC	; ஢
		ANDLW	0F0H		;訩  ID-a
		IORLW   008H		;   ࠢ
		CALL    DEC_SEND_FF	; 08 (⨢ ஢.)
		MOVLW   0B8H^066H^0AEH	;  B8h  24c16 ᯮ
					; ᠭ  (㭨ᠫ쭮)
INS_8704_8706	XORLW   066H^0AEH	;8704 - FAC  24c16   A6h
					;8706 - FAC   24c16   AEh
		BCF	STATUS,007H	; 䫠 " CAAC_CAB8"
SEND_CONSULT	CALL    Rnd_Read_IIC
INS_xx21	MOVWF   29H		; ப  24c16
		DECF    4FH,F
		BTFSC	STATUS,07H	; 뫪 樨 CAAC_CAB8
_send_string_	CALL    DEC_SEND_FF	; 뫠 ᭠砫   ; W <- FFh
		BTFSC   4FH,07H		;᫠  P3 ,
		GOTO    MainLoop	;    24c16
		BTFSS	29H,07H		;  뢠 ਯ⠬
		DECF    29H,F		;᫨ 襭  ⮢,
		BTFSS   29H,07H		; 祬 ᮤন  ப, 
		CALL    Seq_Read_IIC	;  ⮪ FF-
		GOTO    _send_string_

;    ID      24C16
; 室  : RTCC - ன  ID
;            W - ⨩  ID,  ஬   .ࠤ (4e  室)
; 室 : ᫨ ஢  ,  室  STATUS.CY = 1
;	      ⨢ 砥 :
;	      PRV -  ஢
;             PCLATH -     24c16 ( 䫠 訡 /not used/)
;             13h - ᬥ饭   24c16
;	      EEDATA - 訩  ID ஢  UA_link  .ࠤ
;	     室  STATUS.CY = 0
Prov_Search	MOVWF	4EH
		CLRF    PRV
		CLRF	PCLATH		;⪠ 䫠 訡   0 24c16
		MOVLW	0D3H+1		;  D3h  24c16 - ID- ஢
_search_loop_	MOVWF   FSR		; 㪠뢠  ன  ID-a
		CALL    Rnd_Read_IIC
		XORWF   RTCC,W		;஢ઠ ண  ID
		BTFSS   STATUS,Z
		GOTO    _wrong_prov_
		CALL    Seq_Read_IIC
		XORWF   4EH,W		;஢ઠ 襩 ࠤ
		ANDLW   0F0H		; 쥣  ID
		BTFSS	STATUS,Z
		GOTO	_wrong_prov_
KeyAddr_2416	MOVF	4EH,W		;᫥    24c16
KeyAddr_2416_	ANDLW   00FH		;Key0 -> Key4
		MOVWF	13H		;Key1 -> Key5
;++++++++++++++++++++++++++++++++++++++
		XORLW	005H
		BTFSS	STATUS,Z
		GOTO	No_Mk5
		COMF	4BH,W
		ANDLW	00FH
		MOVWF	PRV
No_Mk5
;++++++++++++++++++++++++++++++++++++++
		BTFSC	13H,03H		;Key4 -> Key6
		GOTO	_key_89ABCDEF_	;Key5 -> Key7
		BTFSC	13H,02H		;Key6 -> Key6
		BSF	13H,001H	; Map:  0 1 4/6 5
		BSF	13H,002H	; 8 9 A B C D E F
_key_89ABCDEF_	RRF	13H,W		;Addr = ((Prov+6)*12+Key)*8
		RRF	13H,F
		MOVLW	024H
		CALL	Add_Prov_mul_6
		ADDWF	13H,F		;STATUS.CY <- 0
		SWAPF	13H,F
		MOVLW	007H
		ANDWF	13H,W
		XORWF	13H,F		;ᬥ饭   24c16
		MOVWF	PCLATH		;    24c16
		RETLW	007H		; W <- 7 ; STATUS.CY = 0

_wrong_prov_	INCF    PRV,F		; ᫥饣 ஢
		MOVLW   003H		;
		ADDWF   FSR,W		; ᫥騩 ID
		BTFSS   STATUS,CY	;
		GOTO    _search_loop_	; 0..13
	;	BSF     PCLATH,004H	;⠢ 䫠 訡
	;	RETURN			; STATUS.CY = 1
		ORG	200H
Consult_Table	RETLW	01EH		;CAAC06
		RETLW	020H		;CAAC07
		RETLW	025H		;CAAC08
		RETLW	027H		;CAAC09
		RETLW	02AH		;CAACA3
		RETLW	02DH		;CAAC06
		RETLW	032H		;CAACA8
		RETLW	039H		;CAACA9
		RETLW	03FH		;CAACAA
		RETLW	046H		;CAACAC
		RETLW	04DH		;CAACAD
		RETLW	019H		 ;CAACAB
		RETLW	015H		 ;CAACA1
		MOVF	PRV,W		;CAACA7
		BTFSC	STATUS,Z	;  A7   ?
		RETLW	052H		; LABEL : Ethereal-15GW
		DECF	PCLATH,F	; ஢஢   1 24c16
		ADDLW	080H		; ஢஢   180h
		ADDWF	PRV,W
Add_Prov_mul_6	ADDWF	PRV,W		; +  ஢ * 6
Add_Prov_mul_5	ADDWF	PRV,W		; +  ஢ * 5
Add_Prov_mul_4	ADDWF   PRV,W		; +  ஢ * 4
Add_Prov_mul_3	ADDWF   PRV,W		; +  ஢ * 3
		ADDWF   PRV,W
		ADDWF   PRV,W
		RETURN

Move8_to_18	MOVWF	EEADR		;஢ 8    18h..1Fh
		ADDLW	018H
Move8		CALL    Move4		;஢ 8- 
		GOTO    Move4_

Remote_Byte	COMF	2EH,W		; ஢, ண ᬮਬ
		MOVWF	PRV		; ᭮. ⠭ 
		MOVF	2FH,W		;࠭  
		CALL	KeyAddr_2416_   ;塞    24c16 ; W <- 7
		ANDWF	EEDATA,W	;뤥   
		ADDWF	13H,W		;塞     24c16
Write_4C_IIC	CALL	Set_Addr_IIC
		MOVF	4CH,W		; ६⮬ 
		CALL	Write_IIC	;襬 
		GOTO	Stop_IIC

;INS_CAA402	MOVLW	001H
;		ADDWF	PRV,F		;४祭  ᫥騩 
;		ADDWF	PRV,W		; 0..15
;		MOVWF	PCLATH		;᫨ 16,  ⠢ 䫠 訡
;		BTFSC	STATUS,DC	;᫨ 16, 
;INS_CAA400	CLRF	PRV		;騩 ஢ - ISSUER
;		GOTO	MainLoop

;, 뫠饥 ID-஢, ᣨਤ஢  ஬ 
Nano_A1		CALL    InvSEND_RECV
		CALL	BNano_InvSndRcv	;竨 ன  ID-
		MOVWF   4DH		; ஢  ࠭  4d
		CALL	BNano_InvSndRcv	;竨 ⨩  ID- ஢  箬
		MOVF    FSR,W		;६
		MOVWF   TMP		; ࠭ FSR  28
		MOVF    48H,W		;⥫   ID/祩
		MOVWF   FSR		; ⨫  FSR
		MOVF    4DH,W		;࠭ ன 
		MOVWF   INDIR		; ID ஢  
		INCF    FSR,F
		MOVF    EEDATA,W	;࠭ ⨩ 
		MOVWF   INDIR		; ID ஢   
	;;;	INCF    FSR,W		; 㪠⥫
	;;;	MOVWF   48H		; 㢥稫  
		MOVF	TMP,W		;⠭
		MOVWF   FSR		; FSR  28
		CALL    Byte_Nano	;ࠡ  
Test_Nano	BCF     INTCON,005H	; 䫠 CRYPTED_DATA
		CALL    InvSEND_RECV
		MOVWF   4DH		;   4d
		XORLW   0F0H		; 
		BTFSC   STATUS,Z	;  F0 - ஢ 
		GOTO    Nano_F0
		CALL	BNano_InvSndRcv
		MOVWF   4FH		;   4f
		CALL    Byte_Nano	;ࠡ  
		MOVF    4DH,W		; 
		XORLW   0A1H		; 
		BTFSC   STATUS,Z	;  A1 - ID ஢   
		GOTO    Nano_A1
		XORLW   0A1H^0E2H	; 
		BTFSS	STATUS,Z	; E2 -    
		XORLW   0E2H^0E1H	; 
		BTFSC	STATUS,Z	; E1 -   ⥬/஢ 
		GOTO    Nano_E1_E2
		XORLW	0E1H^0EAH	; 
		BTFSS   STATUS,Z	;  EA - ஢ ᫮
		XORLW   0EAH^0EFH	; 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	;	BTFSC   STATUS,Z	;  EF - ஢ 
	;	BSF     INTCON,005H	;⠢ 䫠 CRYPTED_DATA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		BTFSS   STATUS,Z	;  EF - ஢ 
		GOTO	NanoData_Accept
		BSF     INTCON,005H	;⠢ 䫠 CRYPTED_DATA
		INCF    48H,F		; 㪠⥫
		INCF	48H,F		; 㢥稫  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
NanoData_Accept	DECF    4FH,F		;砥  , ⠥
		BTFSC   4FH,07H   	;   㪫뢠  , ᫨ 
		GOTO    Test_Nano	; ᫥饥 
		CALL    InvSEND_RECV
		CALL    CryptByte_Nano	;ࠡ  
		GOTO    NanoData_Accept

Nano_F0		CALL    DES		;⠥  ; FSR = 18h
		MOVF    4CH,W		; , 뫠 
		CALL    SEND_RECV	;塞  ᨣ (8)
_signature_cmp_	CALL    RECV		;஢ઠ
		XORWF   INDIR,F		; ᮮ⢥⢨
		BTFSS   STATUS,Z	; ஢ 
		BSF     PCLATH,004H	;⠢ 䫠 訡
		INCF    FSR,F		; ࠢ쭮
		BTFSS   FSR,05H   	; ᨣ, ਯ⮡
		GOTO    _signature_cmp_	; 㤥 㫥 ( ᯮ)
		BCF     INTCON,004H	; 䫠 HASH
		MOVF    27H,F		;᫥  
		BTFSC   STATUS,Z	;    ?
		RETLW	018H		;᫨ ,  Eurocrypt-M ; W <- 18h
		MOVLW   002H		;஢
		MOVWF   EEADR		; 8- 
		MOVLW   020H		;  ᮢ 20h..27h
		CALL    Move8		;  ᠬ 1Eh..25h
		MOVF    1EH,W	;饭  ,
		MOVWF   25H	; ᯮ  ᠬ 20h..27h
		MOVF    1FH,W	; 0 1 2 3 4 5 6 7     -
		MOVWF   26H	; 2 3 4 5 6 0 1 7
		RETLW	018H		; W <- 18h
		;  ᯮ  ஢  Viaccess

INS_CAA402	INCF	PROV,F		;४祭  ᫥騩 
		MOVLW	0D2H		;  D2h  0 24c16
		CALL	Rnd_Read_IIC	;  ᫮ ⨢ ஢஢
		SUBWF	PROV,W		;஢ઠ  ॢ襭  ஢
		BTFSS	STATUS,DC
		GOTO	MainLoop
		BSF	PCLATH,004H	;⠢ 䫠 訡
INS_CAA400:	CLRF	PROV		;騩 ஢ - 
		GOTO	MainLoop

INS_CAAC	MOVLW   0ACH		;뫠 AC  ⢥ত
		CALL    SEND_FF
		MOVF    4DH,W		; 樨
		MOVWF   2DH		; ࠭  2d
		BSF     STATUS,006H	;⠢ 䫠 "CAAC"
		BTFSC	4DH,07H		; 権
		BTFSS	4DH,06H		; CAACBx 
		BTFSC   4DH,04H		; CAACEx
		BSF     PCLATH,004H	; ⠢ 䫠 訡
INS_8702	DECF    4FH,F		;⠥ P3   塞
		BTFSC   4FH,07H
		GOTO    MainLoop
		CALL    RECV
	;;;	BTFSC	4CH,03H		;祭 8702/CAAC
	;;;	GOTO	INS_8702	; CAAC 
		XORLW   040H		;᫨ । P3  
		BTFSC   STATUS,Z	; 40h (next), 
		BSF     PCLATH,004H	; ⠢塞 䫠 訡
		GOTO    INS_8702

INS_CAC0	BTFSS   4FH,03H		;  ஢ ᫮
		BTFSS	4FH,04H		; ⢮ 訢  - 12h
		GOTO    Send_ID_Entity	; ID   ᠭ entity
					; - 訢 03  1Ah 
					; EC-M 訢 04  06 
	;	BTFSS   4FH,00H		;  ஢ ᫮
	;	BTFSC   4FH,03H		; ⢮ 訢  - 12h
	;	GOTO    Send_ID_Entity	; ID   ᠭ entity
	;				; - 訢 03  1Ah 
		MOVLW   0EAH		;ਧ ᯥ譮 ஢
		CALL    DEC_SEND_FF	
		MOVLW   010H		;16  ஢ 
		CALL    DEC_SEND_FF	
		MOVLW   00CH		;஢ ᫮
		MOVWF   FSR		; ᯮ  ᠬ 0Ch..1Bh
_send_encrypt_	MOVF    INDIR,W		;᫠ ᫮,
		CALL    SEND_FF
		INCF    FSR,F		; ஢
		DECFSZ  4FH,F		; 
		GOTO    _send_encrypt_	; CA88
		GOTO    MainLoop_LED

INS_CAF0_CAF8	CALL    CryptoPreludeFX	; ५  ਯ⮣䨨
		BTFSC   4CH,03H		;஢ઠ  CAF8
		GOTO    INS_CAF8
INS_CAF0	INCF	PRV,W		;  ᮡ⢥ PPUA
		CALL    Add_Prov_mul_4	;  PPUA  24c16   0
		CALL    Rnd_Read_IIC	;
		MOVWF   1DH		;   SA
		CALL    Seq_Read_IIC	;
		MOVWF   1EH		; ன  SA
		CALL    Seq_Read_IIC	;
		MOVWF   1FH		; ⨩  SA
		CALL    DES		;⠥ 
INS_CAF8	CALL    InvSEND_RECV	;⠥  ᯮ㥬 ⮫쪮  
		BTFSC   STATUS,Z	;祭  ?
		GOTO    _zero_
		BTFSS   4FH,05H		;. ⠫  32-  ?
		BCF     PCLATH,004H	; -  䫠 訡
_zero_		CALL    Byte_Nano	;ࠡ  
		DECFSZ  4FH,F
		GOTO    INS_CAF8
		CALL    DES		;⠥ 
		GOTO    MainLoop

StdDelay_7F	MOVLW	.27		;⥫쭮   9600 
	;	GOTO	Delay_7F
Delay_7F	MOVWF   TMP		;ந쭠 প,
		DECFSZ	TMP,F		;  ࠬ  W
		GOTO	$-1
		RETLW	07FH		; W <- 7Fh

DEC_SEND_FF	DECF    4FH,F		;뫪   RS-232  㬥襭
;					; 稪 뫠 
SEND_FF		MOVWF   EEDATA		;뫪   RS-232, EEDATA <- W
SEND_EEDATA_FF	SWAPF	EEDATA,W	;  
		XORWF	EEDATA,W	; (⭮)
		MOVWF	2AH
		RRF	2AH,W
		XORWF	2AH,F
		BTFSC	2AH,02H
		INCF	2AH,F
		MOVLW	.14
		BTFSS   INTCON,03H	;᫨ 115200,  ࢠ 
		MOVLW   .50+.28+.15
		CALL    Delay_7F	;⮢ ࢠ ; W <- 7Fh
		BCF     PORTB,007H	;-
		TRIS    PORTB		; । ; TRIS 7FH
		MOVLW	009H
		RRF     2AH,F		; STATUS.CY  
		MOVWF   2AH
_send_		BTFSS   INTCON,03H	;᫨ 115200,   প
		CALL    StdDelay_7F
		COMF	EEDATA,W
		RLF     EEDATA,F
		MOVWF   PORTB		;W.7 -> PORTB.7
		DECFSZ  2AH,F
		GOTO    _send_
		MOVLW   .28
		BTFSS   INTCON,03H	;᫨ 115200,   প
		CALL    Delay_7F	; 
		MOVLW   0FFH		; (⮯   뫠)
TRIS_PORTB	TRIS    PORTB		; ਥ
		RETLW   0FFH		; W <- FFh

BNano_InvSndRcv	CALL	Byte_Nano
InvSEND_RECV	COMF    4CH,W		;뫪 ᭮  ਥ
SEND_RECV	CALL    SEND_FF		;뫪  ਥ
RECV		BTFSC   PORTB,07H	;ਥ   RS-232
		GOTO    RECV
		MOVLW   .42
		BTFSS   INTCON,03H	;᫨ 115200,   প
		CALL    Delay_7F
		MOVLW	009H
		MOVWF   2AH
		NOP
_receive_	MOVF    PORTB,W		;PORTB.7 -> W.7
		SUBLW   07FH		;Not(W.7) -> STATUS.CY
		RLF     EEDATA,F
		BTFSS   INTCON,03H	;᫨ 115200,   প
		CALL    StdDelay_7F
		DECFSZ  2AH,F
		GOTO    _receive_
		RRF     EEDATA,F	;  모
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		GOTO	W_EEDATA_RET	;⠢ 䫠 Z  १
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	;	MOVF    EEDATA,W
	;	RETURN			;⠢ 䫠 Z  १
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

PC2_Expand_XOR	MOVWF   29H		;PC2, Expansion Box  XOR 48-
		RRF     29H,F		; १⮢   -  ࠧ
		RRF     29H,W
PC2_Expand_XOR_	MOVWF   29H
		MOVLW   004H		; 6 ࠧ
		MOVWF   TMP
_pc2_		CALL    Read_EEADR	; ⥭  EEDATA ; W <- 7
		INCF	EEADR,F
		ANDWF	EEDATA,W
		ADDLW   01FH
		MOVWF   FSR
		MOVF    INDIR,W
		BTFSC   EEDATA,03H	;訩  訩  ?
		SWAPF   INDIR,W		;᫨ 訩
		ANDWF   EEDATA,W	;뤥 㦭   
		ADDLW   0F0H		;஢   STATUS.CY
		RLF     TMP,F		;⠢塞  ⥫,
		BTFSS	STATUS,CY	;  ६ -
		GOTO    _pc2_		;  稪 横
		MOVF    TMP,W
		XORWF   29H,W
		ANDLW   03FH
		RETURN

CryptByte_Nano	BTFSS	INTCON,05H	;  䫠 CRYPTED_DATA
		GOTO	Byte_Nano	; ஢   
		MOVF    27H,W		;᫥  
		ANDLW   0F0H		;᫨   0000xxxx, 
		MOVLW   05AH		; ᪠ 5Ah,   ⨢ 砥 A5h
		BTFSS   STATUS,Z	; ᫨   , 
		MOVLW   0A5H		; xor- ஢ ᫮
		ANDWF   INDIR,W		;  襬 ᮢᥬ  
		BTFSS   27H,00H		;஢ઠ ⭮ 
		CLRW			; ⭮  祣  塞
		XORWF   EEDATA,W	; ⭮ xor-  襬
		MOVWF   RTCC		; ஢ ᫮
		MOVF    FSR,W		;६ ࠭塞 FSR
		MOVWF   4DH		;  4d
		MOVF    49H,W		;⥫   ஢ ᫮
		MOVWF   FSR		;뢠  ஢ ᫮
		MOVF    RTCC,W		;   
		MOVWF   INDIR		;㥬 祭   
		INCF    49H,F		;த 㪠⥫ 
		MOVF    4DH,W		;⠭ FSR
		MOVWF   FSR		;  4d
Byte_Nano	MOVF    EEDATA,W	;⠭  
		XORWF   INDIR,F		;   楢 
		INCF    FSR,F
		BTFSS   FSR,05H		;   18h..1Fh ?
		RETURN
		;᫨  - ஢
; DES -      
;  室 :  㥬  㥬  - 18h..1Fh L,R
;              ஢ - 20h..27h
;  室 :  ஢    14h..1Fh, 
;             14h..17h-LEFT_HALF 18h..1Bh-LEFT_HALF 1Ch..1Fh-RIGHT_HALF
DES		MOVLW	060H		; 稪
		CALL	SEND_FF		; ⠩-
		MOVLW   010H		;16
		MOVWF   RTCC		; 権
		ANDWF	PCLATH,F
		BSF	PCLATH,000H	; 1 24c16
		GOTO	_rotate_once_	; ࢮ 樨 頥 1 ࠧ

DES_Iteration	CALL    Move4_1C_18	;஥ R    L ; W <- F8h
		CALL    Move4_14_x	;㥬 14h..17h  1Ch..1Fh
					; .  R   
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		MOVF	RTCC,W		; ᫠ 饭   :
		SUBLW	00EH		; 1 1 2 2 2 2 2 2 1 2 2 2 2 2 2 1
		XORLW	006H
		BTFSC	STATUS,CY
		BTFSC	STATUS,Z
		GOTO	_rotate_once_	;1,2,9-  - 頥  ࠧ
		DECFSZ	RTCC,W		;஢ઠ  ᫥ 
		CALL    Rotate_SubKey
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;		DECF	RTCC,W		; 樨  ᬥ饭  ⠡
;		BTFSS   RTCC,03H	;- e d c b a 9 8 7 d c b a 9 8 7
;		ADDLW   007H		; ⮬  -  ᫠ 饭
;		CALL    S_Box_Table_2	;1 1 2 2 2 2 2 2 1 2 2 2 2 2 2 1
;		BTFSC   EEDATA,05H	;᫨   㪠뢠  
;		CALL    Rotate_SubKey	; 饭,  頥 ⥫쭮
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
_rotate_once_	CALL    Rotate_SubKey	;頥   ; W <- 8
		MOVWF	15H		;15 <- 8
		MOVWF   16H		;16 <- 8
		MOVF    27H,W		;Key[7]
		MOVWF   17H		;Key7tmp
		CLRF    2AH		;Lo
		CLRF    14H		;Hi
		MOVF    1CH,W		;R[0]  室 横
_mul_		RRF     17H,F		;Key7tmp
		BTFSC   STATUS,CY
		ADDWF   14H,F		;Hi=+R[0]
		RRF     14H,F		;Hi >>
		RRF     2AH,F		;>> Lo
		DECFSZ  16H,F		; 16   ⮬
		GOTO    _mul_
		ADDWF   27H,W		;R[0]+Key[7]
		BTFSC   STATUS,CY
		INCF    14H,F		; ७  Hi
		ADDWF   2AH,F		;Lo += R[0]+Key[7]
		BTFSC   STATUS,CY
		INCF    14H,F		;७  Hi
		MOVF    14H,W		;Hi
		SUBWF   2AH,F		;Lo -= Hi
		BTFSS   STATUS,CY
		INCF    2AH,F		;Lo+, 稫 New R[0]  2c
		CLRF    14H		;塞  ஢ 
		CLRF    17H		; 16 㦥 㫥 ; 15 = 8
		CLRF	EEADR		;  0 - ⠡  EEPROM 

		RLF     1DH,W
		RLF     2AH,W
		CALL	Pc2EXor_RndRd40
	;	CALL    PC2_Expand_XOR_
	;	CALL    Rnd_Read_IIC_40
		; 15 = 8		;BTFSC   EEDATA,03H
		ANDWF	15H,F		;BSF     15H,003H
		BTFSC   EEDATA,02H
		BSF     17H,004H
		BTFSC   EEDATA,01H
		BSF     14H,006H
		BTFSC   EEDATA,00H
		BSF     16H,006H

		RRF     1FH,W
		RRF     2AH,W
		CALL    PC2_Expand_XOR
		CALL    Rnd_Read_IIC
		BTFSC   EEDATA,03H
		BSF     15H,007H
		BTFSC   EEDATA,02H
		BSF     16H,007H
		BTFSC   EEDATA,01H
		BSF     16H,001H
		BTFSC   EEDATA,00H
		BSF     17H,001H

		RRF     2AH,W
		RRF     1DH,W
		CALL    PC2_Expand_XOR
		CALL    S_Box_Table_1
		BTFSC   EEDATA,03H
		BSF     16H,000H
		BTFSC   EEDATA,02H
		BSF     15H,000H
		BTFSC   EEDATA,01H
		BSF     17H,002H
		BTFSC   EEDATA,00H
		BSF     14H,002H

		RLF     1EH,W
		RLF     1DH,W
		CALL    PC2_Expand_XOR_
		CALL    S_Box_Table_2
		BTFSC   EEDATA,03H
		BSF     17H,006H
		BTFSC   EEDATA,02H
		BSF     16H,004H
		BTFSC   EEDATA,01H
		BSF     15H,006H
		BTFSC   EEDATA,00H
		BSF     14H,007H

		RRF     1DH,W
		RRF     1EH,W
		CALL    PC2_Expand_XOR
		CALL    Rnd_Read_IIC
		BTFSC   EEDATA,07H
		BSF     14H,000H
		BTFSC   EEDATA,06H
		BSF     15H,002H
		BTFSC   EEDATA,05H
		BSF     17H,007H
		BTFSC   EEDATA,04H
		BSF     14H,005H

		RLF     1FH,W
		RLF     1EH,W
		CALL	Pc2EXor_RndRd40
	;	CALL    PC2_Expand_XOR_
	;	CALL    Rnd_Read_IIC_40
		BTFSC   EEDATA,07H
		BSF     14H,004H
		BTFSC   EEDATA,06H
		BSF     17H,003H
		BTFSC   EEDATA,05H
		BSF     15H,005H
		BTFSC   EEDATA,04H
		BSF     16H,005H

		RRF     1EH,W
		RRF     1FH,W
		CALL    PC2_Expand_XOR
		CALL    S_Box_Table_1
		BTFSC   EEDATA,07H
		BSF     17H,000H
		BTFSC   EEDATA,06H
		BSF     15H,004H
		BTFSC   EEDATA,05H
		BSF     16H,002H
		BTFSC   EEDATA,04H
		BSF     14H,001H

		RLF     2AH,W
		RLF     1FH,W
		CALL    PC2_Expand_XOR_
		CALL    S_Box_Table_2
		BTFSC   EEDATA,07H
		BSF     14H,003H
		BTFSC   EEDATA,06H
		BSF     17H,005H
		BTFSC   EEDATA,05H
		BSF     15H,001H
		BTFSC   EEDATA,04H
		BSF     16H,003H

		MOVF    14H,W		;᫨ 䫠 HASH
		XORWF   15H,W		; ⠢,
		BTFSS	INTCON,04H	;  
		CLRW			; ⠬
		XORWF   15H,F		; ᮤন 14  15
		XORWF   18H,W		;XOR ஥ L
		XORWF   14H,F		;  ᮢ 18h..1Bh
		MOVF    19H,W		;
		XORWF   15H,F		; ᢥ
		MOVF    1AH,W		;  १
		XORWF   16H,F		;
		MOVF    1BH,W		; ஢   R  
		XORWF   17H,F		;   14h..17h -  R
		DECFSZ	RTCC,F  	; ᫥   ?
		GOTO    DES_Iteration
; ᫥ 樨 ⠭  , ⮬ १ - 4L 4L 4R
		MOVLW   0FCH		;뫪 14h..17h -> 18h..1Bh
Move4_14_x	MOVWF   EEADR		;ᯮ ⮫쪮  14h..->1Ch..
		MOVLW   014H
		CALL    Move4
		; 砫 楢  
FSR_18h		MOVLW   018H		; FSR <- 18h
		MOVWF   FSR
		RETLW	00CH		; W <- Ch

;##################################################################
;#      EEPROM 24C16   IIC #
;##################################################################

;    24C16 -     
Save_18_1F_24xx	CALL    FSR_18h		;18h -> FSR
_save_8_bytes_	MOVF    INDIR,W
		CALL    Write_IIC
		INCF    FSR,F
		BTFSS   FSR,05H
		GOTO    _save_8_bytes_
Stop_IIC	BCF     PORTB,SDA
		MOVLW   0CFH
		TRIS    PORTB
	;	NOP
		BSF     PORTB,SCK
	;	NOP
		BSF     PORTB,SDA
;NOP_SCK_Down	NOP
SCK_Down	BCF     PORTB,SCK
		RETLW	06FH		; W <- 6Fh

Start_IIC	BSF     PORTB,SDA
		MOVLW   0CFH
		TRIS    PORTB
		BSF     PORTB,SCK
	;	NOP
		BCF     PORTB,SDA
		GOTO    SCK_Down

Pc2EXor_RndRd40	CALL    PC2_Expand_XOR_
Rnd_Read_IIC_40	IORLW	040H
Rnd_Read_IIC	CALL    Set_Addr_IIC
Seq_Read_IIC	CALL    Start_IIC
		BSF	STATUS,CY
		CALL    Send_Header_IIC
Recv_Byte_IIC	MOVLW	0DFH
		TRIS	PORTB
		CALL	Recv_Nibble_IIC
		CALL	Recv_Nibble_IIC	; W <- 0CFh
		TRIS	PORTB		; W = 0CFh
		CALL    Stop_IIC
W_EEDATA_RET	MOVF	EEDATA,W	;⠢ 䫠 Z
		RETURN			;  १

FSR_KeyAddr_IIC	MOVWF	FSR
Set_KeyAddr_IIC	MOVF	13H,W
Set_Addr_IIC	MOVWF	TMP
_retry_		CALL	Start_IIC
		BCF	STATUS,CY
		CALL	Send_Header_IIC
		BTFSC	STATUS,CY
		GOTO	_retry_
		MOVF	TMP,W
		GOTO	Write_IIC

Send_Header_IIC	RLF	PCLATH,W
;;;		ANDLW	00FH
		IORLW	0A0H
Write_IIC	MOVWF	EEDATA
		MOVLW	0CFH
		TRIS	PORTB
		CALL	Send_Nibble_IIC
		CALL	Send_Nibble_IIC
		MOVLW	0DFH
		TRIS	PORTB
Recv_Bit_IIC	BSF	PORTB,SCK
	;	NOP
		BSF	STATUS,CY
		BTFSS	PORTB,SDA
		BCF	STATUS,CY
		GOTO	SCK_Down

Send_Nibble_IIC	CALL	_send_next_bit_
		CALL	_send_next_bit_
		CALL	_send_next_bit_
_send_next_bit_	RLF	EEDATA,F
Send_Bit_IIC	BTFSC	STATUS,CY
		BSF	PORTB,SDA
		BTFSS	STATUS,CY
		BCF	PORTB,SDA
		BSF	PORTB,SCK
		GOTO	SCK_Down	;GOTO	NOP_SCK_Down

Recv_Nibble_IIC	CALL	_recv_next_bit_
		CALL	_recv_next_bit_
		CALL	_recv_next_bit_
_recv_next_bit_	CALL	Recv_Bit_IIC
		RLF	EEDATA,F
		RETLW	0CFH		; W <- 0CFh

		ORG	2007H

		DATA	3FF9h

		ORG	2100H

		DATA	0021h, 0014h, 002Ah, 0049h, 008Bh, 0042h
		DATA	004Ah, 0083h, 0022h, 001Bh, 0081h, 0089h
		DATA	002Bh, 0023h, 0012h, 0011h, 0044h, 0019h
		DATA	001Ah, 0029h, 0024h, 0013h, 008Ah, 0041h
		DATA	0086h, 0017h, 002Ch, 008Dh, 002Eh, 002Fh
		DATA	004Ch, 001Dh, 0027h, 008Eh, 0085h, 001Eh
		DATA	0016h, 0087h, 002Dh, 001Fh, 0045h, 008Fh
		DATA	004Eh, 0046h, 0047h, 0015h, 008Ch, 001Ch

		DATA	0068h, 0062h, 0000h, 0014h, 0029h	;ATR
		DATA 	0000h, 0025h, 0018h, 0077h, 003Fh	; 10 bytes

		END
